!-----------------------
! madgraph - a Feynman Diagram package by Tim Stelzer and Bill Long 
! (c) 1993
!
! Filename: writesub.f
!-----------------------
 
      subroutine writesub(ngraphs,nexternal,nqed,nqcd)
!***************************************************************************
!     writes out the subroutines
!***************************************************************************
      implicit none

! Arguments

      integer ngraphs,nqed,nqcd,nexternal


! Local Variables

      character*75 buff
      character*20 name
      character*3 temp
      integer i,jchar,ishift,nlength


! Global Variables

      integer           neigen
      common /to_color/ neigen

      integer       nwf,wnum(999)
      common/toopt/ nwf,wnum

      character*15 gname
      integer iname
      common/to_name/iname,gname
      character*60 proc
      integer iproc
      common/to_write/iproc,proc

!-----------
! Begin Code
!-----------
      ishift = iname
      nlength = ishift
      open(unit=92,file=gname(1:iname)//'.f',status='unknown')

      name = gname(1:iname)
      call upper_case(name)

      print*,'Writing function ',name(1:iname) ,
     &     ' in file ',GNAME(1:iname)//'.f.'

      call writesum

      buff = 'REAL*8 FUNCTION '
      jchar = 17
      buff(jchar:jchar+ishift) = name(1:iname)
      jchar = jchar+ishift
      ishift= 3
      buff(jchar:jchar+ishift) = '(P1'
      jchar =jchar+ishift
      ishift = 4
      do i=2,nexternal
         write(buff(jchar:jchar+ishift),20) i
         jchar=jchar+ishift
      enddo
      buff(jchar:jchar+5)= ',NHEL)'
      write(92,'(6x,a)') buff(1:jchar+5)

! write comments

      write(92,5) ' '
      write(92,5) 'FUNCTION GENERATED BY MADGRAPH'
      write(92,5) 'RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS'
      write(92,5) 'FOR THE POINT IN PHASE SPACE P1,P2,P3,P4,...'
      write(92,5) 'AND HELICITY NHEL(1),NHEL(2),....'
      write(92,5) ' '
      write(92,5) 'FOR PROCESS '//proc(1:iproc)
      write(92,5) ' '

      write(92,10) 'IMPLICIT NONE'

! write parameters

      write(92,5) ' '
      write(92,5) 'CONSTANTS'
      write(92,5) ' '

      buff = 'INTEGER    NGRAPHS,    NEIGEN,    NEXTERNAL'
      write(92,10) buff(1:50)
      buff = 'PARAMETER (NGRAPHS=???,NEIGEN=???,NEXTERNAL=?)'
      write(buff(20:22),'(i3)') ngraphs
      write(buff(31:33),'(i3)') neigen
      write(buff(45:45),'(i1)') nexternal
      write(92,10) buff(1:50)
      write(92,10) 'REAL*8     ZERO'
      write(92,10) 'PARAMETER (ZERO=0D0)'

! write arguement declarations

      write(92,5) ' '
      write(92,5) 'ARGUMENTS '
      write(92,5) ' '

      buff = 'REAL*8 P1(0:3)'
      jchar= 15
      ishift = 8
      do i=2,nexternal
         write(buff(jchar:jchar+ishift),30) i
         jchar=jchar+ishift
      enddo
      write(92,10) buff
      buff = 'INTEGER NHEL(NEXTERNAL)'
      write(92,10) buff


! write local declarations

      write(92,5) ' '
      write(92,5) 'LOCAL VARIABLES '
      write(92,5) ' '

      write(92,10) 'INTEGER I,J'
      write(92,10) 'REAL*8 EIGEN_VAL(NEIGEN), EIGEN_VEC(NGRAPHS,NEIGEN)'
      write(92,10) 'COMPLEX*16 ZTEMP'
      write(92,10) 'COMPLEX*16 AMP(NGRAPHS)'
      buff = 'COMPLEX*16 W???(6), W???(6), W???(6), W???(6), W???(6)'
      jchar = 13
      ishift= 9
      do i=1,nwf
         if (mod(i,5) .eq. 1 .and. i .ne. 1) then
            write(92,10) buff(1:60)
            jchar = 13
         endif
         call makestringamp(i,temp)
         if (i .lt. 10) then
            buff(jchar:jchar)=temp(1:1)
            buff(jchar+1:jchar+3)='(6)'
            buff(jchar+4:jchar+5)='  '
         else if (i .lt. 100) then
            buff(jchar:jchar+1)=temp(1:2)
            buff(jchar+2:jchar+4)='(6)'
            buff(jchar+5:jchar+5)=' '
         else if (i .lt. 1000) then
            buff(jchar:jchar+2)=temp(1:3)
            buff(jchar+3:jchar+5)='(6)'
         endif
         jchar = jchar+ishift
      enddo
      write(92,10) buff(1:jchar-4)


! write global declarations

      write(92,5) ' '
      write(92,5) 'GLOBAL VARIABLES'
      write(92,5) ' '

      if (nqed .ne. 0) then
         write(92,10) 'REAL*8         GW, GWWA, GWWZ'
         write(92,10) 'COMMON /COUP1/ GW, GWWA, GWWZ'
         write(92,10) 'REAL*8         GAL(2),GAU(2),GAD(2),GWF(2)'
         write(92,10) 'COMMON /COUP2A/GAL,   GAU,   GAD,   GWF'
         write(92,10) 'REAL*8         GZN(2),GZL(2),GZU(2),GZD(2),G1(2)'
         write(92,10) 'COMMON /COUP2B/GZN,   GZL,   GZU,   GZD,   G1'
         write(92,10) 'REAL*8         GWWH,GZZH,GHHH,GWWHH,GZZHH,GHHHH'
         write(92,10) 'COMMON /COUP3/ GWWH,GZZH,GHHH,GWWHH,GZZHH,GHHHH'
         write(92,10) 'COMPLEX*16     GH(2,12)'
         write(92,10) 'COMMON /COUP4/ GH'
         write(92,10) 'REAL*8         WMASS,WWIDTH,ZMASS,ZWIDTH'
         write(92,10) 'COMMON /VMASS1/WMASS,WWIDTH,ZMASS,ZWIDTH'
         write(92,10) 'REAL*8         AMASS,AWIDTH,HMASS,HWIDTH'
         write(92,10) 'COMMON /VMASS2/AMASS,AWIDTH,HMASS,HWIDTH'
      endif
      if (nqcd .ne. 0) then
         write(92,10) 'REAL*8           GG(2), G'
         write(92,10) 'COMMON /COUPQCD/ GG,    G'
      endif
      write(92,10) 'REAL*8            FMASS(12), FWIDTH(12)'
      write(92,10) 'COMMON /FERMIONS/ FMASS,     FWIDTH'


      write(92,5) ' '
      write(92,5) 'COLOR DATA'
      write(92,5) ' '
      
      do while (.true.)
         read(99,'(a)',end=99) buff
         write(92,'(a)') buff
      enddo
 99   continue

      write(92,5) '----------'
      write(92,5) 'BEGIN CODE'
      write(92,5) '----------'

      do while (.true.)
         read(91,'(a)',end=999) buff
         write(92,'(a)') buff
      enddo
 999  continue

      buff(1:nlength) = name(1:nlength)
      buff(nlength+1:nlength+8) = ' = 0.D0'
      write(92,10) buff(1:nlength+8)
      write(92,10) 'DO I = 1, NEIGEN'
      write(92,10) '    ZTEMP = (0.D0,0.D0)'
      write(92,10) '    DO J = 1, NGRAPHS'
      write(92,10) '        ZTEMP = ZTEMP + EIGEN_VEC(J,I)*AMP(J)'
      write(92,10) '    ENDDO'
      buff(1:4) = '    '
      buff(5:nlength+5) = name(1:nlength)
      buff(nlength+6:nlength+6) = '='
      buff(nlength+7:2*nlength+7) = name(1:nlength)
      buff(2*nlength+7:2*nlength+39)=
     &     '+ZTEMP*EIGEN_VAL(I)*CONJG(ZTEMP)'
      write(92,10) buff(1:2*nlength+39)
      write(92,10) 'ENDDO'
      buff(1:46)='CALL GAUGECHECK(AMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,'
      buff(47:61)='NGRAPHS,NEIGEN)'
      write(92,15) buff(1:61)
      write(92,10) 'END'

      close(92)

 5    format('C ',A)
 10   format(6X,A)
 15   format('C',6X,A)
 20   format(', P',I1)
 30   format(',P',I1,'(0:3)')
      end

 
      subroutine writesum
!***************************************************************************
!     writes out the subroutine
!***************************************************************************
      implicit none

! Constants

      integer    maxlines
      parameter (maxlines=8)

! Local Variables

      character*75 buff,fname
      character*20 name
      integer i,jchar,ishift,nlength,j,flen,nexternal
      integer nhel(maxlines,3**maxlines),step(maxlines),ihel,iden

! Global Variables

      integer        iline(-maxlines:maxlines)
      common/to_proc/iline

      character*15 gname
      integer iname
      common/to_name/iname,gname
      integer         nincoming
      common/to_proc2/nincoming
      character*60 proc
      integer iproc
      common/to_write/iproc,proc

!-----------
! Begin Code
!-----------
      nexternal=iline(0)
      iden=1
      do i=1,nexternal
         if (abs(iline(i)) .eq. 23) then
            step(i) = 1                        !Massive Vector Boson
            if (i .le. nincoming) iden=iden*3 
         elseif (abs(iline(i)) .eq. 24) then 
            step(i) = 1                        !Massive Vector Boson
            if (i .le. nincoming) iden=iden*3 
         elseif (abs(iline(i)) .eq. 25) then 
            step(i) = 3                        !Scalar
            if (i .le. nincoming) iden=iden*1 
         else
            step(i) = 2
            if (i .le. nincoming) iden=iden*2 
         endif
      enddo
      ishift = iname
      nlength = ishift

      name = gname(1:iname)
      call upper_case(name)

      call sethel(nhel,step,nexternal,ihel)

      buff = 'REAL*8 FUNCTION S'
      jchar = 18
      buff(jchar:jchar+ishift) = name(1:iname)
      jchar = jchar+ishift
      ishift= 3
      buff(jchar:jchar+ishift) = '(P1'
      jchar =jchar+ishift
      ishift = 4
      do i=2,nexternal
         write(buff(jchar:jchar+ishift),20) i
         jchar=jchar+ishift
      enddo
      buff(jchar:jchar)= ')'
      write(92,10) buff(1:jchar)
      FNAME= buff(18:jchar)
      FNAME(JCHAR-17:JCHAR-17+13)=',NHEL(1,IHEL))'
      FLEN = jchar-17+13

! write comments

      write(92,5) ' '
      write(92,5) 'FUNCTION GENERATED BY MADGRAPH'
      write(92,5) 'RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS'
      write(92,5) 'AND HELICITIES'
      write(92,5) 'FOR THE POINT IN PHASE SPACE P1,P2,P3,P4,...'
      write(92,5) ' '
      write(92,5) 'FOR PROCESS '//proc(1:iproc)
      write(92,5) ' '

      write(92,10) 'IMPLICIT NONE'

! write parameters

      write(92,5) ' '
      write(92,5) 'CONSTANTS'
      write(92,5) ' '
      buff = 'INTEGER    NEXTERNAL,   NCOMB'
      write(92,10) buff(1:50)
      buff = 'PARAMETER (NEXTERNAL=?, NCOMB=???)'
      write(buff(22:22),'(i1)') nexternal
      write(buff(31:33),'(i3)') ihel
      write(92,10) buff(1:34)

      write(92,5) ' '
      write(92,5) 'ARGUMENTS '
      write(92,5) ' '
      buff = 'REAL*8 P1(0:3)'
      jchar= 15
      ishift = 8
      do i=2,nexternal
         write(buff(jchar:jchar+ishift),30) i
         jchar=jchar+ishift
      enddo
      write(92,10) buff

      write(92,5) ' '
      write(92,5) 'LOCAL VARIABLES '
      write(92,5) ' '
      buff = 'INTEGER NHEL(NEXTERNAL,NCOMB),NTRY'
      write(92,10) buff
      write(92,10) 'REAL*8 T'
      buff = 'REAL*8 '
      buff(8:7+iname)=name(1:iname)
      write(92,10) buff
      write(92,10) 'INTEGER IHEL'
      write(92,10) 'LOGICAL GOODHEL(NCOMB)'
      write(92,10) 'DATA GOODHEL/NCOMB*.FALSE./'
      write(92,10) 'DATA NTRY/0/'
      BUFF = 'DATA (NHEL(IHEL,???),IHEL=1,?) /'
      write(buff(29:29),'(i1)') nexternal
      do i=1,ihel
         write(buff(17:19),'(i3)') i
         jchar=33
         ishift = 4
         do j=1,nexternal
            write(buff(jchar:jchar+ishift),'(I3,a)') nhel(j,i),','
            jchar=jchar+ishift
         enddo
         jchar=jchar-1
         write(buff(jchar:jchar),'(a1)') '/'
         write(92,10) buff(1:jchar)
      enddo
      write(92,5) '----------'
      write(92,5) 'BEGIN CODE'
      write(92,5) '----------'
      buff(1:1)='S'
      buff(2:iname+1) = name(1:iname)
      buff(iname+2:iname+7) = ' = 0d0'
      write(92,10) buff(1:iname+7)
      write(92,10) 'NTRY=NTRY+1'
      write(92,10) 'DO IHEL=1,NCOMB'
      write(92,10) '    IF (GOODHEL(IHEL) .OR. NTRY .LT. 10) THEN'
      buff(1:8) = '          '
      buff(8:9)= 'T='
      buff(10:10+flen) = fname(1:flen)  
      write(92,10) buff(1:10+flen)
      buff(1:8)='       S'
      jchar=9
      buff(jchar:jchar+iname-1) = name(1:iname)
      jchar=jchar+iname
      buff(jchar:jchar+3) = ' = S'
      jchar=jchar+4
      buff(jchar:jchar+iname-1) = name(1:iname)
      jchar=jchar+iname
      buff(jchar:jchar+3) = ' + T'
      write(92,10) buff(1:jchar+3)
      buff = '        IF (T .GT. 0D0 .AND. .NOT. GOODHEL(IHEL)) THEN'
      write(92,10) buff(1:54)
      write(92,10) '            GOODHEL(IHEL)=.TRUE.'
      write(92,10) '            WRITE(*,*) IHEL,T'
      write(92,10) '        ENDIF'
      write(92,10) '    ENDIF'
      write(92,10) 'ENDDO'
      buff(1:1) = 'S'
      jchar=2
      buff(jchar:jchar+iname-1) = name(1:iname)
      jchar=jchar+iname
      buff(jchar:jchar+3) = ' = S'
      jchar=jchar+4
      buff(jchar:jchar+iname-1) = name(1:iname)
      jchar=jchar+iname
      buff(jchar:jchar+2) = ' / '
      jchar=jchar+3
      write(buff(jchar:jchar+1),'(i2)') iden
      jchar=jchar+2
      buff(jchar:jchar+2)='D0'
      write(92,10) buff(1:jchar+2)
      write(92,10) 'END'
      write(92,10) ' '
      write(92,10) ' '

 5    format('C ',A)
 10   format(6X,A)
 15   format('C',6X,A)
 20   format(', P',I1)
 30   format(',P',I1,'(0:3)')
      end


      subroutine writesub_f90(ngraphs,nexternal,nqed,nqcd)
!***************************************************************************
!     writes out the subroutine for Fortran 90 
!***************************************************************************
      implicit none

! Arguments

      integer ngraphs,nqed,nqcd,nexternal

! Local Variables

      character*75 buff
      character*20 name
      character*3 temp
      integer i,jchar,ishift,nlength

! Global Variables

      integer           neigen
      common /to_color/ neigen

      integer       nwf,wnum(999)
      common/toopt/ nwf,wnum

      character*15 gname
      integer iname
      common/to_name/iname,gname
      character*60 proc
      integer iproc
      common/to_write/iproc,proc

!-----------
! Begin Code
!-----------
      ishift = iname
      nlength = ishift
      open(unit=92,file=gname(1:iname)//'.f',status='unknown')

      name = gname(1:iname)
      call lower_case(name)

      print*,'Writing function ',name(1:iname) ,
     &     ' in file ',gname(1:iname)//'.f.'

      call writesum_f90

      buff = 'function '
      jchar = 10
      buff(jchar:jchar+ishift) = name(1:iname)
      jchar = jchar+ishift
      ishift= 3
      buff(jchar:jchar+ishift) = '(p1'
      jchar =jchar+ishift
      do i=2,nexternal
         write(buff(jchar:jchar+ishift),20) i
         jchar=jchar+ishift
      enddo
      buff(jchar:jchar+5)= ',nhel)'
      write(92,10) buff(1:jchar+5)

! write comments

      write(92,5) ' '
      write(92,5) 'Function generated by MADGRAPH'
      write(92,5) 'Returns amplitude squared summed/avg over colors'
      write(92,5) 'for the point in phase space p1,p2,p3,p4,...'
      write(92,5) 'and helicity nhel(1),nhel(2),....'
      write(92,5) ' '
      write(92,5) 'For process '//proc(1:iproc)
      write(92,5) ' '

      write(92,10) 'implicit none'

! write parameters

      write(92,5) ' '
      write(92,5) 'Constants'
      write(92,5) ' '

      write(92,10) 'integer,parameter :: D = selected_real_kind(14,100)'
      write(92,11) 'integer,parameter :: ngraphs   = ',ngraphs
      write(92,11) 'integer,parameter :: neigen    = ',neigen
      write(92,11) 'integer,parameter :: nexternal = ',nexternal
      write(92,10) 'real(D),parameter :: zero = 0.0_D'

! write argument declarations

      write(92,5) ' '
      write(92,5) 'Arguments '
      write(92,5) ' '

      write(92,10) 'real(D)                :: '//name(1:iname)
      buff =       'real(D),dimension(0:3),intent(in) :: p1'
      jchar= 40
      ishift = 3
      do i=2,nexternal
         write(buff(jchar:jchar+ishift),20) i
         jchar=jchar+ishift
      enddo
      write(92,10) buff
      write(92,10) 'integer,dimension(nexternal),intent(in) :: nhel'

! write local declarations

      write(92,5) ' '
      write(92,5) 'Local Variables '
      write(92,5) ' '

      write(92,10) 'integer                           :: i'
      write(92,10) 'real(D),dimension(neigen)         :: eigen_val' 
      write(92,10) 'real(D),dimension(ngraphs,neigen) :: eigen_vec'
      write(92,10) 'complex(D)                        :: ztemp'
      write(92,10) 'complex(D),dimension(ngraphs)     :: amp'
      buff = 'complex(D),dimension(6) :: w???, w???, w???, w???, w???'
      jchar = 29
      ishift= 6
      do i=1,nwf
         if (mod(i,5) .eq. 1 .and. i .ne. 1) then
            write(92,10) buff(1:60)
            jchar = 29
         endif
         call makestringamp(i,temp)
         if (i .lt. 10) then
            buff(jchar:jchar)=temp(1:1)
            buff(jchar+1:jchar+2)='  '
         else if (i .lt. 100) then
            buff(jchar:jchar+1)=temp(1:2)
            buff(jchar+2:jchar+2)=' '
         else if (i .lt. 1000) then
            buff(jchar:jchar+2)=temp(1:3)
         endif
         jchar = jchar+ishift
      enddo
      write(92,10) buff(1:jchar-4)


! write global declarations

      write(92,5) ' '
      write(92,5) 'Global Variables'
      write(92,5) ' '

      if (nqed .ne. 0) then
         write(92,10) 'real(D)              :: gw, gwwa, gwwz'
         write(92,10) 'common /coup1/          gw, gwwa, gwwz'
         write(92,10) 'real(D),dimension(2) :: gal,gau,gad,gwf'
         write(92,10) 'common /coup2a/         gal,gau,gad,gwf'
         write(92,10) 'real(D),dimension(2) :: gzn,gzl,gzu,gzd,g1'
         write(92,10) 'common /coup2b/         gzn,gzl,gzu,gzd,g1'
         write(92,10) 'real(D)     :: gwwh,gzzh,ghhh,gwwhh,gzzhh,ghhhh'
         write(92,10) 'common /coup3/ gwwh,gzzh,ghhh,gwwhh,gzzhh,ghhhh'
         write(92,10) 'complex(D),dimension(2,12) :: gh'
         write(92,10) 'common /coup4/                gh'
         write(92,10) 'real(D)     :: wmass,wwidth,zmass,zwidth'
         write(92,10) 'common /vmass1/wmass,wwidth,zmass,zwidth'
         write(92,10) 'real(D)     :: amass,awidth,hmass,hwidth'
         write(92,10) 'common /vmass2/amass,awidth,hmass,hwidth'
      endif
      if (nqcd .ne. 0) then
         write(92,10) 'real(D)       :: gg(2), g'
         write(92,10) 'common /coupqcd/ gg,    g'
      endif
      write(92,10) 'real(D),dimension(12) :: fmass,fwidth'
      write(92,10) 'common /fermions/        fmass,fwidth'

      write(92,5) ' '
      write(92,5) 'Color Data'
      write(92,5) ' '

      do while (.true.)
         read(99,'(a)',end=99) buff
         call lower_case(buff)
         buff(52:52) = 'e'
         buff(56:58) = '_D/'
         write(92,'(a)') buff
      enddo
 99   continue

      write(92,5) '----------'
      write(92,5) 'Begin Code'
      write(92,5) '----------'

      do while (.true.)
         read(91,'(a)',end=999) buff
         call lower_case(buff)
         write(92,'(a)') buff
      enddo
 999  continue

      buff(1:nlength) = name(1:nlength)
      buff(nlength+1:nlength+8) = ' = 0.0_D'
      write(92,10) buff(1:nlength+8)
      write(92,10) 'do i = 1, neigen'
      write(92,10) '    ztemp = sum(eigen_vec(:,i)*amp(:))'
      buff(1:4) = '    '
      buff(5:nlength+5) = name(1:nlength)
      buff(nlength+6:nlength+6) = '='
      buff(nlength+7:2*nlength+7) = name(1:nlength)
      buff(2*nlength+7:2*nlength+39)=
     &     '+ztemp*eigen_val(i)*conjg(ztemp)'
      write(92,10) buff(1:2*nlength+39)
      write(92,10) 'enddo'
      buff(1:46)='call gaugecheck(amp,ztemp,eigen_vec,eigen_val,'
      buff(47:61)='ngraphs,neigen)'
      write(92,15) buff(1:61)
      write(92,10) 'end'

      close(92)

 5    format('! ',a)
 10   format(6x,a)
 11   format(6x,a,i5)
 15   format('!',6x,a)
 20   format(',p',i1)
      end


      subroutine writesum_f90
!***************************************************************************
!     writes out the subroutine - f90 version
!***************************************************************************
      implicit none

! Constants

      integer    maxlines
      parameter (maxlines=8)

! Local Variables

      character*75 buff,fname
      character*30 plist
      character*20 name
      character*21 sname
      integer isname,iplist
      integer i,jchar,ishift,j,flen,nexternal
      integer nhel(maxlines,3**maxlines),step(maxlines),ihel,iden

! Global Variables

      integer        iline(-maxlines:maxlines)
      common/to_proc/iline

      character*15 gname
      integer iname
      common/to_name/iname,gname
      integer         nincoming
      common/to_proc2/nincoming
      character*60 proc
      integer iproc
      common/to_write/iproc,proc

!-----------
! Begin Code
!-----------

      nexternal=iline(0)
      iden=1
      do i=1,nexternal
         if (abs(iline(i)) .eq. 23) then
            step(i) = 1                        !Massive Vector Boson
            if (i .le. nincoming) iden=iden*3 
         elseif (abs(iline(i)) .eq. 24) then 
            step(i) = 1                        !Massive Vector Boson
            if (i .le. nincoming) iden=iden*3 
         elseif (abs(iline(i)) .eq. 25) then 
            step(i) = 3                        !Scalar
            if (i .le. nincoming) iden=iden*1 
         else
            step(i) = 2
            if (i .le. nincoming) iden=iden*2 
         endif
      enddo

      isname = iname+1
      name = gname(1:iname)
      call lower_case(name)
      sname = 's'//name(1:iname)
      plist(1:2) = 'p1'
      jchar = 3
      do i=2,nexternal
         write(plist(jchar:jchar+3),20) i
         jchar=jchar+3
      enddo
      iplist = 3*nexternal-1

      call sethel(nhel,step,nexternal,ihel)

      buff = 'function '//sname(:isname)//'('//plist(:iplist)//')'
      jchar = 11+isname+iplist
      write(92,10) buff(1:jchar)

      fname= buff(11:jchar)
      fname(jchar-10:jchar-10+16)=',nhel(1:?,ihel))'
      flen = jchar-10+16
      write(fname(flen-8:flen-8),'(i1)') nexternal

! write comments

      write(92,5) ' '
      write(92,5) 'Function generated by MADGRAPH.'
      write(92,5) 'Returns amplitude squared summed/avg over colors'
      write(92,5) 'and helicities'
      write(92,5) 'for the point in phase space p1,p2,p3,p4,...'
      write(92,5) ' '
      write(92,5) 'For process '//proc(1:iproc)
      write(92,5) ' '


      write(92,10) 'implicit none'

! write parameters

      write(92,5) ' '
      write(92,5) 'Constants'
      write(92,5) ' '

      write(92,10) 'integer,parameter :: D = selected_real_kind(14,100)'
      write(92,11) 'integer,parameter :: nexternal = ',nexternal
      write(92,11) 'integer,parameter :: ncomb     = ',ihel

! write argument declarations

      write(92,5) ' '
      write(92,5) 'Arguments '
      write(92,5) ' '

      write(92,10) 'real(D)                :: '//sname(1:isname)
      buff =       'real(D),dimension(0:3),intent(in) :: '
      buff(38:) = plist(:iplist)
      write(92,10) buff

! write external function interface

      write(92,5)  ' '
      write(92,5)  'External Function'
      write(92,5)  ' '

      write(92,10) 'interface'
      write(92,10) ' function '//name(:iname)//'('//
     &                            plist(:iplist)//',nhel)'
      write(92,10) '  real(D)                           :: '//
     &                            name(:iname)
      write(92,10) '  real(D),dimension(0:3),intent(in) :: '//
     &                            plist(:iplist)
      write(92,10) '  integer,dimension(nexternal),intent(in) :: nhel'
      write(92,10) ' end function '
      write(92,10) 'end interface'

! write local declarations

      write(92,5) ' '
      write(92,5) 'Local Variables '
      write(92,5) ' '

      write(92,10)'integer                           :: ihel,ntry'
      write(92,10)'integer,dimension(nexternal,ncomb):: nhel'
      write(92,10)'real(D)                           :: t'
      write(92,10)'logical,dimension(ncomb)          :: goodhel'

! write data tables

      write(92,5) ' '
      write(92,5) 'Helicity combination tables'
      write(92,5) ' '

      write(92,10) 'data goodhel/ncomb*.false./'
      write(92,10) 'data ntry/0/'
      buff = 'data nhel(1:?,???) /'
      write(buff(13:13),'(i1)') nexternal
      do i=1,ihel
         write(buff(15:17),'(i3)') i
         jchar=22
         ishift = 4
         do j=1,nexternal
            write(buff(jchar:jchar+ishift),'(i3,a)') nhel(j,i),','
            jchar=jchar+ishift
         enddo
         jchar=jchar-1
         write(buff(jchar:jchar),'(a1)') '/'
         write(92,10) buff(1:jchar)
      enddo

      write(92,5) '----------'
      write(92,5) 'Begin Code'
      write(92,5) '----------'
      write(92,10) sname(1:isname)//' = 0.0_D'
      write(92,10) 'ntry=ntry+1'
      write(92,10) 'do ihel=1,ncomb'
      write(92,10) '    if (goodhel(ihel) .or. ntry < 10) then'
      write(92,10) '        t='//fname(1:flen)
      write(92,10) 
     &'        '//sname(1:isname)//' = '//sname(1:isname)//' + t'
      write(92,10) 
     &'        if (t > 0.0_D .and. .not. goodhel(ihel)) then'
      write(92,10) '            goodhel(ihel)=.true.'
      write(92,10) '            write(*,*) ihel,t'
      write(92,10) '        endif'
      write(92,10) '    endif'
      write(92,10) 'enddo'
      buff =        sname(1:isname)//' = '//sname(1:isname)//'/??.0_D'
      jchar=2*isname + 5
      write(buff(jchar:jchar+1),'(i2)') iden
      write(92,10) buff(1:jchar+6)
      write(92,10) 'end'
      write(92,10) ' '
      write(92,10) ' '


 5    format('! ',a)
 10   format(6x,a)
 11   format(6x,a,i5)
 15   format('!',6x,a)
 20   format(',p',i1)
      end
      

      
      subroutine sethel(nhel,step,npart,ihel)
c************************************************************************
c     Sets up all possible helicity combinations in nhel(ipart,ihel)
c     given the number of particles, and the step size to be used
c     for each particle
c     The first state is always -1, the next is 0 or 1 depending onstep
c************************************************************************
      implicit none

!     Constants
      
      integer    maxlines
      parameter (maxlines=8)

!     Arguments
      
      integer nhel(maxlines,3**maxlines),step(maxlines),npart,ihel

!     Local

      integer ipart,iflip
      logical gotone

      ihel=1
      do ipart=1,npart
         nhel(ipart,ihel)=-1
      enddo
      gotone=.true.
      do while (gotone)
c         write(*,'(8I4)'),ihel,(nhel(ipart,ihel),ipart=1,npart)
         ihel=ihel+1
         do ipart=1,npart
            nhel(ipart,ihel)=nhel(ipart,ihel-1)
         enddo
         gotone = .false.
         iflip = npart
         do while(.not. gotone .and. iflip .gt. 0)
            nhel(iflip,ihel) = nhel(iflip,ihel)+step(iflip)
            if (nhel(iflip,ihel) .gt. 1) then
               nhel(iflip,ihel) = -1
               iflip =iflip-1
            else
               gotone=.true.
            endif
         enddo
      enddo
      ihel=ihel-1
      end


!-------------------------------------
      subroutine lower_case(string)
      implicit none

! Constants

      integer    char_a,              char_z
      parameter (char_a = ichar('A'), char_z = ichar('Z'))
      integer    lcshift
      parameter (lcshift = ichar('a') - ichar('A'))


! Argument

      character*(*) string

! Local Variable

      integer i

!-----------
! Begin Code
!-----------
      do i=1,len(string)
         if (ichar(string(i:i)) .ge. char_a .and.
     &       ichar(string(i:i)) .le. char_z) then
            string(i:i)=char(ichar(string(i:i))+lcshift)
         end if
      end do
      end

!-------------------------------------
      subroutine upper_case(string)
      implicit none

! Constants

      integer    char_a,              char_z
      parameter (char_a = ichar('a'), char_z = ichar('z'))
      integer    ucshift
      parameter (ucshift = ichar('A') - ichar('a'))

! Argument

      character*(*) string

! Local Variable

      integer i

!-----------
! Begin Code
!-----------
      do i=1,len(string)
         if (ichar(string(i:i)) .ge. char_a .and.
     &       ichar(string(i:i)) .le. char_z) then
            string(i:i)=char(ichar(string(i:i))+ucshift)
         end if
      end do
      end
